package db.table;

import java.util.List;
import java.util.Optional;

import db.Table;
import entity.Frequentation;

public class FrequentationTable extends Table<Frequentation>{

	private static FrequentationTable instance;
	private static EspaceTable et = EspaceTable.getInstance();
	private static UsagerTable ut = UsagerTable.getInstance();
	
	private FrequentationTable() {
		// Private constructor for singleton
	}

	@Override
	public Frequentation getById(long id) {
		return link(super.getById(id));
	}

	@Override
	public List<Frequentation> getByField(String fieldname, Object value) {
		return link(super.getByField(fieldname, value));
	}

	@Override
	public List<Frequentation> getWhere(List<String> where, List<Object> params) {
		return link(super.getWhere(where, params));
	}

	@Override
	public List<Frequentation> getAll() {
		return link(super.getAll());
	}

	@Override
	public void save(Frequentation obj) {
		et.save(obj.espace);
		ut.save(obj.usager);
		obj.espaceId = obj.espace.id;
		obj.usagerId = obj.usager.id;
		super.save(obj);
	}

	private Frequentation link(Frequentation obj) {
		if(obj == null) {
			return null;
		}
		obj.espace = et.getById(obj.espaceId);
		obj.usager = ut.getById(obj.usagerId);
		return obj;
	}
	
	private List<Frequentation> link(List<Frequentation> list) {
		if(list.isEmpty()) {
			return list;
		}
		list.forEach(elt -> link(elt));
		return list;
	}
	
	public static FrequentationTable getInstance() {
		if(instance == null) {
			instance = new FrequentationTable();
		}
		return instance;
	}	
	
}
